<?php
function _blockUpdate()
{
	global $objDatabase, $_ARRAYLANG;

	$arrTables = $objDatabase->MetaTables('TABLES');
	if ($arrTables !== false) {
		if (!in_array(DBPREFIX."module_block_blocks", $arrTables)) {
			$query = "CREATE TABLE `".DBPREFIX."module_block_blocks` (
				`id` int(10) unsigned NOT NULL auto_increment,
				`content` text NOT NULL,
				`name` varchar(255) NOT NULL default '',
				`random` int(1) NOT NULL default '0',
				`active` int(1) NOT NULL default '0',
				PRIMARY KEY  (`id`)
				) TYPE=MyISAM";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}

		if (!in_array(DBPREFIX."module_block_rel_lang", $arrTables)) {
			$query = "CREATE TABLE ".DBPREFIX."module_block_rel_lang (`block_id` int(10) unsigned NOT NULL default '0', `lang_id` int(10) unsigned NOT NULL default '0') TYPE=MyISAM";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		setUpdateMsg($_ARRAYLANG['TXT_UNABLE_DETERMINE_DATABASE_STRUCTURE']);
		return false;
	}

	$objFWLanguage = &new FWLanguage();
	$arrLanguages = &$objFWLanguage->getLanguageArray();

	$query = "SELECT id FROM ".DBPREFIX."module_block_blocks";
	if (($objBlock = $objDatabase->Execute($query)) !== false) {
		while (!$objBlock->EOF) {
			foreach ($arrLanguages as $arrLanguage) {
				$query = "SELECT block_id FROM ".DBPREFIX."module_block_rel_lang WHERE lang_id=".$arrLanguage['id']." AND block_id=".$objBlock->fields['id'];
				if (($objLang = $objDatabase->SelectLimit($query, 1)) !== false) {
					if ($objLang->RecordCount() == 0) {
						$query = "INSERT INTO ".DBPREFIX."module_block_rel_lang (`block_id`, `lang_id`) VALUES (".$objBlock->fields['id'].", ".$arrLanguage['id'].")";
						if ($objDatabase->Execute($query) === false) {
							return _databaseError($query, $objDatabase->ErrorMsg());
						}
					}
				} else {
					return _databaseError($query, $objDatabase->ErrorMsg());
				}
			}
			$objBlock->MoveNext();
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	if (!in_array(DBPREFIX.'module_block_rel_pages', $arrTables)) {
		$query = "CREATE TABLE `".DBPREFIX."module_block_rel_pages` (
				`block_id` INT( 7 ) NOT NULL DEFAULT '0',
				`page_id` INT( 7 ) NOT NULL DEFAULT '0',
				`lang_id` INT( 7 ) NOT NULL DEFAULT '0'
				) TYPE = MYISAM";

		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		$query = "ALTER TABLE `".DBPREFIX."module_block_rel_pages` CHANGE `block_id` `block_id` INT( 7 ) NOT NULL DEFAULT '0'";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
		$query = "ALTER TABLE `".DBPREFIX."module_block_rel_pages` CHANGE `page_id` `page_id` INT( 7 ) NOT NULL DEFAULT '0'";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
		$query = "ALTER TABLE `".DBPREFIX."module_block_rel_pages` CHANGE `lang_id` `lang_id` INT( 7 ) NOT NULL DEFAULT '0'";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."module_block_rel_lang");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_block_rel_lang'));
		return false;
	}

	if (!in_array('all_pages', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_block_rel_lang` ADD `all_pages` INT( 1 ) NOT NULL DEFAULT '0'";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		$query = "ALTER TABLE `".DBPREFIX."module_block_rel_lang` CHANGE `all_pages` `all_pages` INT( 1 ) NOT NULL DEFAULT '0'";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."module_block_blocks");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_block_blocks'));
		return false;
	}

	if (!in_array('global', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_block_blocks` ADD `global` INT( 1 ) NOT NULL DEFAULT '0' AFTER `random`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		$query = "ALTER TABLE `".DBPREFIX."module_block_blocks` CHANGE `global` `global` INT( 1 ) NOT NULL DEFAULT '0'";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array('order', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_block_blocks` ADD `order` INT( 1 ) NOT NULL DEFAULT '0'";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		$query = "ALTER TABLE `".DBPREFIX."module_block_blocks` CHANGE `order` `order` INT( 1 ) NOT NULL DEFAULT '0'";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$query = "ALTER TABLE `".DBPREFIX."module_block_blocks`
		CHANGE `name` `name` varchar(255) NOT NULL default '',
		CHANGE `active` `active` int(1) NOT NULL default '0'";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	if (!in_array(DBPREFIX.'module_block_settings', $arrTables)) {
		$query = "CREATE TABLE `".DBPREFIX."module_block_settings` (
					`id` INT( 7 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
					`name` VARCHAR( 100 ) NOT NULL DEFAULT '',
					`value` VARCHAR( 100 ) NOT NULL DEFAULT ''
					) TYPE = MYISAM";

		if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		$query = "ALTER TABLE `".DBPREFIX."module_block_settings` CHANGE `name` `name` VARCHAR( 100 ) NOT NULL DEFAULT ''";
		if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
		}
		$query = "ALTER TABLE `".DBPREFIX."module_block_settings` CHANGE `value` `value` VARCHAR( 100 ) NOT NULL DEFAULT ''";
		if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$query = "SELECT id FROM ".DBPREFIX."module_block_settings WHERE name = 'blockGlobalSeperator'";
	$objResult = $objDatabase->SelectLimit($query, 1);
	if ($objResult !== false) {
		if ($objResult->RecordCount() == 0) {
			$query = "INSERT INTO `".DBPREFIX."module_block_settings` VALUES (1, 'blockGlobalSeperator', '<br /><br />');";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."module_block_blocks");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_block_blocks'));
		return false;
	}

	if (!in_array('random_2', $arrColumns) && !in_array('random_3', $arrColumns)) {
		$query = 	"ALTER TABLE `".DBPREFIX."module_block_blocks` ADD `random_2` INT( 1 ) NOT NULL DEFAULT '0' AFTER `random` ,
					ADD `random_3` INT( 1 ) NOT NULL DEFAULT '0' AFTER `random_2` ;";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	return true;
}
?>