<?php
function _calendarUpdate()
{
	global $objDatabase, $_ARRAYLANG;

	$arrTables = $objDatabase->MetaTables('TABLES');
	if ($arrTables === false) {
		setUpdateMsg($_ARRAYLANG['TXT_UNABLE_DETERMINE_DATABASE_STRUCTURE']);
		return false;
	}

	if (!in_array(DBPREFIX.'module_calendar_form_data', $arrTables)) {
		$query = "CREATE TABLE `".DBPREFIX."module_calendar_form_data` (
				  `reg_id` int(10) NOT NULL,
				  `field_id` int(10) NOT NULL,
				  `data` text NOT NULL
				) TYPE=MyISAM";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array(DBPREFIX.'module_calendar_form_fields', $arrTables)) {
		$query = "CREATE TABLE `".DBPREFIX."module_calendar_form_fields` (
				  `id` int(7) NOT NULL auto_increment,
				  `note_id` int(10) NOT NULL,
				  `name` text NOT NULL,
				  `type` int(1) NOT NULL,
				  `required` int(1) NOT NULL,
				  `order` int(3) NOT NULL,
				  `key` int(7) NOT NULL,
				  PRIMARY KEY  (`id`)
				) TYPE=MyISAM";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array(DBPREFIX.'module_calendar_registrations', $arrTables)) {
		$query = "CREATE TABLE `".DBPREFIX."module_calendar_registrations` (
				  `id` int(7) NOT NULL auto_increment,
				  `note_id` int(7) NOT NULL,
				  `time` int(14) NOT NULL,
				  `host` varchar(255) NOT NULL,
				  `ip_address` varchar(15) NOT NULL,
				  `type` int(1) NOT NULL,
				  PRIMARY KEY  (`id`)
				) TYPE=MyISAM";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array(DBPREFIX.'module_calendar_access', $arrTables)) {
		$query = "CREATE TABLE `".DBPREFIX."module_calendar_access` (
					`id` int( 11 ) unsigned NOT NULL AUTO_INCREMENT ,
					`name` varchar( 64 ) NOT NULL default '',
					`description` varchar( 255 ) NOT NULL default '',
					`access_id` int( 11 ) unsigned NOT NULL default '0',
					`type` enum( 'global', 'frontend', 'backend' ) NOT NULL default 'global',
					PRIMARY KEY ( `id` )
					) AUTO_INCREMENT =1;";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$query = "SELECT id FROM ".DBPREFIX."module_calendar_access WHERE `name`='showNote'";
	$objCheck = $objDatabase->SelectLimit($query, 1);
	if ($objCheck !== false) {
		if ($objCheck->RecordCount() == 0) {
			$query = "INSERT INTO `".DBPREFIX."module_calendar_access` ( `id` , `name` , `description` , `access_id` , `type`) VALUES (NULL , 'showNote', 'Community Events einsehen', '116', 'frontend');";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	if (!in_array(DBPREFIX.'module_calendar_settings', $arrTables)) {
		$query = "CREATE TABLE `".DBPREFIX."module_calendar_settings` (
					`setid` INT( 7 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
					`setname` VARCHAR( 255 ) NOT NULL ,
					`setvalue` TEXT NOT NULL
					) TYPE = MYISAM";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$query = "SELECT setid FROM ".DBPREFIX."module_calendar_settings WHERE `setid`='1'";
	$objCheck = $objDatabase->SelectLimit($query, 1);
	if ($objCheck !== false) {
		if ($objCheck->RecordCount() == 0) {
			$query = "INSERT INTO `".DBPREFIX."module_calendar_settings` ( `setid` , `setname` , `setvalue` ) VALUES ('1' , 'mailTitle', 'Neuer Termin');";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "SELECT setid FROM ".DBPREFIX."module_calendar_settings WHERE `setid`='2'";
	$objCheck = $objDatabase->SelectLimit($query, 1);
	if ($objCheck !== false) {
		if ($objCheck->RecordCount() == 0) {
			$query = "INSERT INTO `".DBPREFIX."module_calendar_settings` ( `setid` , `setname` , `setvalue` ) VALUES ('2' , 'mailContent', 'Hallo [[FIRSTNAME]] [[LASTNAME]] Auf [[URL]] wurde ein neuer Termin fr ihre Gruppe aufgeschaltet. Mit folgendem Link knnen Sie sich fr diesen Anlass an- oder abmelden. [[REG_LINK]] Freundliche Grsse [[URL]] - Team Diese Nachricht wurde automatisch generiert [[DATE]]');";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "SELECT setid FROM ".DBPREFIX."module_calendar_settings WHERE `setid`='3'";
	$objCheck = $objDatabase->SelectLimit($query, 1);
	if ($objCheck !== false) {
		if ($objCheck->RecordCount() == 0) {
			$query = "INSERT INTO `".DBPREFIX."module_calendar_settings` ( `setid` , `setname` , `setvalue` ) VALUES ('3' , 'mailConTitle', '[[REG_TYPE]] erfolgreich eingetragen');";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "SELECT setid FROM ".DBPREFIX."module_calendar_settings WHERE `setid`='4'";
	$objCheck = $objDatabase->SelectLimit($query, 1);
	if ($objCheck !== false) {
		if ($objCheck->RecordCount() == 0) {
			$query = "INSERT INTO `".DBPREFIX."module_calendar_settings` ( `setid` , `setname` , `setvalue` ) VALUES ('4' , 'mailConContent', 'Hallo [[FIRSTNAME]] [[LASTNAME]] Ihre [[REG_TYPE]] zum Termin &quot;[[TITLE]] vom [[START_DATE]]&quot; wurde in unserem System erfolgreich eingetragen. Freundliche Grsse [[URL]] - Team Diese Nachricht wurde automatisch generiert [[DATE]] ');";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX.'module_calendar');
	if ($arrColumns === false) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'contrexx_module_calendar'));
		return false;
	}


	if (!in_array('link', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_calendar` CHANGE `info` `link` VARCHAR( 255 ) NOT NULL DEFAULT 'http://'";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array('placeName', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_calendar` CHANGE `place` `placeName` VARCHAR( 255 ) NOT NULL";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}


	$arrFields = array(
		'pic'				=> "ADD `pic` VARCHAR( 255 ) NOT NULL DEFAULT ''",
		'attachment'		=> "ADD `attachment` VARCHAR( 255 ) NOT NULL DEFAULT '' AFTER `pic`",
		'placeStreet'		=> "ADD `placeStreet` VARCHAR( 255 ) NOT NULL DEFAULT '' AFTER `attachment`",
		'placeZip'			=> "ADD `placeZip` VARCHAR( 255 ) NOT NULL DEFAULT '' AFTER `placeStreet`",
		'placeLink'			=> "ADD `placeLink` VARCHAR( 255 ) NOT NULL DEFAULT '' AFTER `placeZip`",
		'placeMap'			=> "ADD `placeMap` VARCHAR( 255 ) NOT NULL DEFAULT '' AFTER `placeLink`",
		'access'			=> "ADD `access` INT( 1 ) NOT NULL DEFAULT '0' AFTER `priority`",
		'organizerName'		=> "ADD `organizerName` VARCHAR( 255 ) NOT NULL DEFAULT '' AFTER `placeMap`",
		'organizerStreet'	=> "ADD `organizerStreet` VARCHAR( 255 ) NOT NULL DEFAULT '' AFTER `organizerName`",
		'organizerZip'		=> "ADD `organizerZip` VARCHAR( 255 ) NOT NULL DEFAULT '' AFTER `organizerStreet`",
		'organizerMail'		=> "ADD `organizerMail` VARCHAR( 255 ) NOT NULL DEFAULT '' AFTER `organizerZip`",
		'organizerLink'		=> "ADD `organizerLink` VARCHAR( 255 ) NOT NULL DEFAULT '' AFTER `organizerMail`",
		'organizerPlace'	=> "ADD `organizerPlace` VARCHAR( 255 ) NOT NULL DEFAULT '' AFTER `organizerZip`",
		'placeCity'			=> "ADD `placeCity` VARCHAR( 255 ) NOT NULL DEFAULT '' AFTER `placeZip`",
		'key'				=> "ADD `key` VARCHAR( 255 ) NOT NULL DEFAULT ''",
		'num'				=> "ADD `num` INT( 5 ) NOT NULL DEFAULT '0'",
		'mailTitle'			=> "ADD `mailTitle` VARCHAR( 255 ) NOT NULL DEFAULT ''",
		'mailContent'		=> "ADD `mailContent` TEXT NOT NULL",
		'registration'		=> "ADD `registration` INT( 1 ) NOT NULL DEFAULT '0'",
		'groups'			=> "ADD `groups` TEXT NOT NULL",
		'all_groups'		=> "ADD `all_groups` INT( 1 ) NOT NULL DEFAULT '0'",
		'public'			=> "ADD `public` INT( 1 ) NOT NULL DEFAULT '0'"
	);

	foreach ($arrFields as $fieldName => $fieldQuery) {
		if (!in_array($fieldName, $arrColumns)) {
			$query = "ALTER TABLE `".DBPREFIX."module_calendar` ".$fieldQuery;
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	}

	if (!in_array('notification', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_calendar` ADD `notification` INT( 1 ) NOT NULL";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array('notification_address', $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_calendar` ADD `notification_address` VARCHAR( 255 ) NOT NULL DEFAULT ''";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$query = "SELECT setid FROM ".DBPREFIX."module_calendar_settings WHERE `setid`='5'";
	$objCheck = $objDatabase->SelectLimit($query, 1);
	if ($objCheck !== false) {
		if ($objCheck->RecordCount() == 0) {
			$query = "INSERT INTO `".DBPREFIX."module_calendar_settings` ( `setid` , `setname` , `setvalue` ) VALUES ('5' , 'mailNotTitle', '')";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "SELECT setid FROM ".DBPREFIX."module_calendar_settings WHERE `setid`='6'";
	$objCheck = $objDatabase->SelectLimit($query, 1);
	if ($objCheck !== false) {
		if ($objCheck->RecordCount() == 0) {
			$query = "INSERT INTO `".DBPREFIX."module_calendar_settings` ( `setid` , `setname` , `setvalue` ) VALUES ('6', 'mailNotContent', '')";
			if ($objDatabase->Execute($query) === false) {
				return _databaseError($query, $objDatabase->ErrorMsg());
			}
		}
	} else {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$query = "ALTER TABLE `".DBPREFIX."module_calendar` CHANGE `name` `name` varchar(100) NOT NULL default ''";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	return true;
}
?>